
# python 3
import GameLogic
import mathutils
import socket
import pickle # serializing and de-serializing

# Get owner
controller = GameLogic.getCurrentController()
owner = controller.owner

host = "localhost"
ClientPort = 10001

# Set socket client only one time at the first frame
if not owner['OneTime'] :

    # Set UDP socket
    GameLogic.socketClient = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
    
    # Bind the socket to host
    GameLogic.socketClient.bind((host, ClientPort))
    
    # Set Buffer size
    GameLogic.socketClient.setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, 1024)
    
    # If no data are found, pass
    GameLogic.socketClient.setblocking(0)
    
    # Set prop to pass test
    owner['OneTime'] = True


#------------if RECEIVE UDP --------------#
try:
    # Get data in buffer
    UpData, SRIP = GameLogic.socketClient.recvfrom(1024)
    
    # De-serialize, return tuples
    test = pickle.loads(UpData)
    
    # Set Position and orientation
    owner.worldPosition = (test[0], test[1], test[2])
    
    # Orientation must be a matrix
    owner_ori = mathutils.Matrix(((test[3], test[4], test[5]) , (test[6], test[7], test[8]) , (test[9], test[10], test[11])))
    owner.worldOrientation = owner_ori
    
except :
    pass
































#import socket
#import pickle
#import mathutils

## Get owner
#controller = GameLogic.getCurrentController()
#owner = controller.owner

#ClientHost = '127.0.0.1'
#ClientPort = 10001


#sClient = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
#sClient.connect((ClientHost, ClientPort))
#sClient.setblocking(0)

##-------------- RECEIVE -----------------#
#try:
#    Data, SRIP = sClient.recv(1024)
#    print (Data)
#    
#except socket.error as msg:
#    print("msg = ", msg)
#    pass

#sClient.close()

















#    ClientIP = '127.0.0.1'
#    ClientPort = 10001
#    
#    GameLogic.sClient = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
#    GameLogic.sClient.bind((ClientIP, ClientPort))
#    #GameLogic.sClient.setblocking(0)
#    GameLogic.sClient.settimeout(0.04)

#    owner['OneTime'] = True


#UDP_data = pickle.loads(Data)
#print ("UDP_data ", UDP_data)

#owner.position = ([UDP_data[0][0]-4 ,UDP_data[0][1]-4 ,UDP_data[0][2]])
#owner.position = ([UDP_data[0]-4 ,UDP_data[1]-4 ,UDP_data[2]])
#owner.position = UDP_data
## 
#bazar = [[UDP_data[1][0][0],UDP_data[1][0][1],UDP_data[1][0][2]], [UDP_data[1][1][0],UDP_data[1][1][1],UDP_data[1][1][2]], [UDP_data[1][2][0],UDP_data[1][2][1],UDP_data[1][2][2]]]


#owner.localOrientation = bazar

#--------------- THE-END ----------------#



